## supertuxkart 0.9.3

=== CMakeLists.txt ===
# root CMakeLists for the SuperTuxKart project
project(SuperTuxKart)
set(PROJECT_VERSION "0.9.3")

cmake_minimum_required(VERSION 2.8.4)
if(NOT (CMAKE_MAJOR_VERSION VERSION_LESS 3))
  cmake_policy(SET CMP0043 OLD)
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake")
include(CMakeDependentOption)

set(DEPENDENCIES "dependencies")
# In case of 64-bit windows, use a different path for dependencies
# so that both dependencies can be installed next to each other
if ( WIN32 AND (CMAKE_SIZEOF_VOID_P EQUAL 8 ) )
    set(DEPENDENCIES "dependencies-64bit")
endif()

include(BuildTypeSTKRelease)
if (NOT CMAKE_BUILD_TYPE)
    message(STATUS "No build type selected, default to STKRelease")
    set(CMAKE_BUILD_TYPE "STKRelease")
endif()

option(SERVER_ONLY "Create a server only (i.e. no graphics or sound)" OFF)
option(USE_FRIBIDI "Support for right-to-left languages" ON)
option(CHECK_ASSETS "Check if assets are installed in ../stk-assets" ON)
option(USE_SYSTEM_ANGELSCRIPT "Use system angelscript instead of built-in angelscript. If you enable this option, make sure to use a compatible version." OFF)
option(ENABLE_WAYLAND_DEVICE "Enable Wayland device for linux build" OFF)

CMAKE_DEPENDENT_OPTION(BUILD_RECORDER "Build opengl recorder" ON
    "NOT SERVER_ONLY;NOT USE_GLES2;NOT APPLE" OFF)

if (UNIX AND NOT APPLE)
    option(USE_GLES2 "Use OpenGL ES2 renderer" OFF)
endif()

if(UNIX OR MINGW)
    option(DEBUG_SYMBOLS "Compile with debug symbols" OFF)
endif()

if(MSVC AND (MSVC_VERSION LESS 1900))
    # Normally hide the option to build wiiuse on VS, since it depends
    # on the installation of the Windows DDK (Driver Developer Kit),
    # which also needs an absolute path :(
    option(WIIUSE_BUILD "Build wiiuse lib (only for developers)" OFF)
    mark_as_advanced(WIIUSE_BUILD)
else()
    set(WIIUSE_BUILD ON)
endif()

if(MINGW OR CYGWIN OR SERVER_ONLY)
    option(USE_WIIUSE "Support for wiimote input devices" OFF)
else()
    option(USE_WIIUSE "Support for wiimote input devices" ON)
endif()

if(UNIX AND NOT APPLE)
    option(USE_ASAN   "Build with Leak/Address sanitizer" OFF)
    option(USE_LIBBFD "Use libbfd for crash reporting and leak check" OFF)
endif()

set(STK_SOURCE_DIR "src")
set(STK_DATA_DIR "${PROJECT_SOURCE_DIR}/data")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/bin")

# Define install paths
set(STK_INSTALL_BINARY_DIR "bin" CACHE
    STRING "Install executable to this directory, absolute or relative to CMAKE_INSTALL_PREFIX")
set(STK_INSTALL_DATA_DIR "share/supertuxkart" CACHE
    STRING "Install data folder to this directory, absolute or relative to CMAKE_INSTALL_PREFIX")

# These variables enable MSVC to find libraries located in "dependencies"
if(WIN32)
    set(ENV{PATH} "$ENV{PATH};${PROJECT_SOURCE_DIR}/${DEPENDENCIES}/include")
    set(ENV{LIB} ${PROJECT_SOURCE_DIR}/${DEPENDENCIES}/lib)
    set(ENV{OPENALDIR} ${PROJECT_SOURCE_DIR}/${DEPENDENCIES})
    add_definitions(-D_IRR_STATIC_LIB_)
    add_definitions(-DNO_IRR_COMPILE_WITH_X11_)
endif()

if(USE_GLES2)
    add_definitions(-DUSE_GLES2)
    add_definitions(-D_IRR_COMPILE_WITH_OGLES2_ -DNO_IRR_COMPILE_WITH_OPENGL_)
endif()

if(SERVER_ONLY)
    add_definitions(-DSERVER_ONLY)
    add_definitions(-DNO_IRR_COMPILE_WITH_X11_)
endif()

#if(DISABLE_VPX)
#    add_definitions(-DNO_VPX)
#endif()

if(UNIX OR MINGW)
    if(DEBUG_SYMBOLS)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g")
    endif()
endif()

# Build the Bullet physics library
add_subdirectory("${PROJECT_SOURCE_DIR}/lib/bullet")
include_directories("${PROJECT_SOURCE_DIR}/lib/bullet/src")

# Build the ENet UDP network library
add_subdirectory("${PROJECT_SOURCE_DIR}/lib/enet")
include_directories("${PROJECT_SOURCE_DIR}/lib/enet/include")

# Build glew library
if(NOT USE_GLES2 AND NOT SERVER_ONLY)
    add_definitions(-DGLEW_NO_GLU)
    add_subdirectory("${PROJECT_SOURCE_DIR}/lib/glew")
    include_directories("${PROJECT_SOURCE_DIR}/lib/glew/include")
endif()

if(MSVC OR APPLE)
    if (NOT APPLE)
    # Build zlib library
    add_subdirectory("${PROJECT_SOURCE_DIR}/lib/zlib")
    include_directories("${PROJECT_SOURCE_DIR}/lib/zlib")

    set(ZLIB_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/lib/zlib" "${PROJECT_BINARY_DIR}/lib/zlib/")
    set(ZLIB_LIBRARY zlibstatic)
    endif()

    # Build png library
    set(SKIP_INSTALL_ALL TRUE)
    set(PNG_STATIC TRUE CACHE BOOL "Build static lib")
    set(PNG_TESTS FALSE CACHE BOOL "Build libpng tests")
    set(PNG_SHARED FALSE CACHE BOOL "Build shared lib")
    add_subdirectory("${PROJECT_SOURCE_DIR}/lib/libpng")
    include_directories("${PROJECT_SOURCE_DIR}/lib/libpng")

    set(PNG_PNG_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/lib/libpng/")
    set(PNG_LIBRARY png_static)
endif()

# Add jpeg library
if (APPLE)
    add_subdirectory("${PROJECT_SOURCE_DIR}/lib/jpeglib")
    include_directories("${PROJECT_SOURCE_DIR}/lib/jpeglib")
    set(JPEG_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/lib/jpeglib/")
    set(JPEG_LIBRARY jpeglib)
else()
    find_package(JPEG REQUIRED)
    include_directories(${JPEG_INCLUDE_DIR})
endif()

if (BUILD_RECORDER)
    find_library(OPENGLRECORDER_LIBRARY NAMES openglrecorder libopenglrecorder PATHS "${PROJECT_SOURCE_DIR}/${DEPENDENCIES}/lib")
    find_path(OPENGLRECORDER_INCLUDEDIR NAMES openglrecorder.h PATHS "${PROJECT_SOURCE_DIR}/${DEPENDENCIES}/include")
    if (NOT OPENGLRECORDER_LIBRARY OR NOT OPENGLRECORDER_INCLUDEDIR)
        if(PROJECT_VERSION STREQUAL "git")
            message(WARNING "libopenglrecorder not found, disabling in-game recorder. "
                "To use recorder, install libopenglrecorder.")
            set(OPENGLRECORDER_LIBRARY CACHE INTERNAL "")
            set(OPENGLRECORDER_INCLUDEDIR CACHE INTERNAL "")
            set(BUILD_RECORDER OFF)
        else()
            message(FATAL_ERROR "libopenglrecorder not found. "
            "Either install libopenglrecorder or disable in-game recorder with -DBUILD_RECORDER=0")
        endif()
    else()
        include_directories(${OPENGLRECORDER_INCLUDEDIR})
        mark_as_advanced(OPENGLRECORDER_LIBRARY OPENGLRECORDER_INCLUDEDIR)
        add_definitions(-DENABLE_RECORDER)
    endif()
endif()

if(NOT SERVER_ONLY AND NOT USE_GLES2)
    add_subdirectory("${PROJECT_SOURCE_DIR}/lib/graphics_utils")
    include_directories("${PROJECT_SOURCE_DIR}/lib/graphics_utils")
endif()

# Build the irrlicht library
add_subdirectory("${PROJECT_SOURCE_DIR}/lib/irrlicht")
include_directories("${PROJECT_SOURCE_DIR}/lib/irrlicht/include")

# Build the Wiiuse library
# Note: wiiuse MUST be declared after irrlicht, since otherwise
# (at least on VS) irrlicht will find wiiuse io.h file because
# of the added include directory.
if(USE_WIIUSE)
    if(WIIUSE_BUILD)
        add_subdirectory("${PROJECT_SOURCE_DIR}/lib/wiiuse")
    endif()
    include_directories("${PROJECT_SOURCE_DIR}/lib/wiiuse")
endif()

# Set include paths
include_directories(${STK_SOURCE_DIR})

if(APPLE)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -arch x86_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -arch x86_64 -F/Library/Frameworks")
elseif(MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")   # Enable multi-processor compilation (faster)
endif()


# Build the angelscript library if not in system
if(USE_SYSTEM_ANGELSCRIPT)
    find_package(Angelscript)
    if(ANGELSCRIPT_FOUND)
        include_directories(${Angelscript_INCLUDE_DIRS})
    else()
        message(FATAL_ERROR "Angelscript not found. "
            "Either install angelscript or use built-in version using "
            "-DUSE_SYSTEM_ANGELSCRIPT=0")
    endif()
else()
    add_subdirectory("${PROJECT_SOURCE_DIR}/lib/angelscript/projects/cmake")
    include_directories("${PROJECT_SOURCE_DIR}/lib/angelscript/include")
    set(Angelscript_LIBRARIES angelscript)
endif()

# OpenAL
if(APPLE)
    # In theory it would be cleaner to let CMake detect the right dependencies. In practice, this means that if a OSX user has
    # unix-style installs of Vorbis/Ogg/OpenAL/etc. they will be picked up over our frameworks. This is blocking when I make releases :
    # the mac I use to make STK releases does have other installs of vorbis/ogg/etc. which aren't compatible with STK, so letting
    # CMake pick the library it wants essentially means I can't build.
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -framework OpenAL")
    set(OPENAL_LIBRARY)
else()
    find_package(OpenAL REQUIRED)
    include_directories(${OPENAL_INCLUDE_DIR})
endif()

# OggVorbis
if(APPLE)
    # In theory it would be cleaner to let CMake detect the right dependencies. In practice, this means that if a OSX user has
    # unix-style installs of Vorbis/Ogg/OpenAL/etc. they will be picked up over our frameworks. This is blocking when I make releases :
    # the mac I use to make STK releases does have other installs of vorbis/ogg/etc. which aren't compatible with STK, so letting
    # CMake pick the library it wants essentially means I can't build.
    set(CMAKE_CXX_FLAGS "${CMAKE_C_FLAGS} -I/Library/Frameworks/Ogg.framework/Versions/A/Headers -I/Library/Frameworks/Vorbis.framework/Versions/A/Headers")
else()
    find_package(OggVorbis REQUIRED)
    include_directories(${OGGVORBIS_INCLUDE_DIRS})
endif()

# Freetype
find_package(Freetype)
if(FREETYPE_FOUND)
    include_directories(${FREETYPE_INCLUDE_DIRS})
else()
    message(FATAL_ERROR "Freetype not found. "
        "Freetype is required to display characters in SuperTuxKart. ")
endif()

# Fribidi
if(USE_FRIBIDI)
    find_package(Fribidi)
    if(FRIBIDI_FOUND)
        include_directories(${FRIBIDI_INCLUDE_DIRS})
    else()
        message(FATAL_ERROR "Fribidi not found. "
            "Either install fribidi or disable bidi support with -DUSE_FRIBIDI=0 "
            "(if you don't use a right-to-left language then you don't need this).")
    endif()
endif()

# OpenGL
if(NOT USE_GLES2 AND NOT SERVER_ONLY)
    find_package(OpenGL REQUIRED)
    include_directories(${OPENGL_INCLUDE_DIR})
endif()

if(USE_LIBBFD)
    find_package(Libbfd)
    if(LIBBFD_FOUND)
        add_definitions(-DENABLE_LIBBFD)
        include_directories(${LIBBFD_INCLUDE_DIRS})
    else()
        set(USE_LIBBFD OFF CACHE BOOL "Use libbfd for crash reporting and leak check" FORCE)
        message(WARNING "Libbfd not found, disable integrated stack trace.")
    endif()
endif()

# Set some compiler options
if(UNIX OR MINGW)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++0x")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-unused-function")
endif()

if(MINGW AND CMAKE_BUILD_TYPE MATCHES Release)
    SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--subsystem,windows")
endif()

if(WIN32)
    # By default windows.h has macros defined for min and max that screw up everything
    add_definitions(-DNOMINMAX)

    # And shut up about unsafe stuff
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)

    # Avoid timespec structure redeclaration on Visual Studio 2015
    if (NOT (MSVC_VERSION LESS 1900))
        add_definitions(-DHAVE_STRUCT_TIMESPEC)
    endif()
endif()

if(MSVC)
    # VS will automatically add NDEBUG for release mode, but only _DEBUG in debug mode.
    # Since STK uses DEBUG, this is added for debug compilation only:
    set_property(DIRECTORY PROPERTY COMPILE_DEFINITIONS_DEBUG DEBUG)
else()
    # All non VS generators used create only a single compile mode, so
    # compile flags can be simplye be added
    if(CMAKE_BUILD_TYPE MATCHES Debug)
        add_definitions(-DDEBUG)
    else()
        add_definitions(-DNDEBUG)
    endif()
endif()

# TODO: remove this switch
add_definitions(-DHAVE_OGGVORBIS)

if(WIN32)
    configure_file("${STK_SOURCE_DIR}/../tools/windows_installer/icon_rc.template" "${PROJECT_BINARY_DIR}/tmp/icon.rc")
endif()

# Provides list of source and header files (STK_SOURCES and STK_HEADERS)
include(sources.cmake)

# Generate source groups useful for MSVC project explorer
include(cmake/SourceGroupFunctions.cmake)

=== lib/bullet/CMakeLists.txt ===
# CMakeLists.txt for Bullet in STK

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src/)

if(APPLE)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -arch x86_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -arch x86_64 -F/Library/Frameworks")
endif()

# libbulletmath
add_library(bulletmath STATIC
	src/LinearMath/btAabbUtil2.h           src/LinearMath/btMotionState.h
	src/LinearMath/btAlignedAllocator.cpp  src/LinearMath/btPoolAllocator.h
	src/LinearMath/btAlignedAllocator.h    src/LinearMath/btQuadWord.h
	src/LinearMath/btAlignedObjectArray.h  src/LinearMath/btQuaternion.h
	src/LinearMath/btConvexHull.cpp        src/LinearMath/btQuickprof.cpp
	src/LinearMath/btConvexHull.h          src/LinearMath/btQuickprof.h
	src/LinearMath/btConvexHullComputer.h  src/LinearMath/btConvexHullComputer.cpp
	src/LinearMath/btDefaultMotionState.h  src/LinearMath/btRandom.h
	src/LinearMath/btGeometryUtil.cpp      src/LinearMath/btScalar.h
	src/LinearMath/btGeometryUtil.h        src/LinearMath/btSerializer.cpp
        src/LinearMath/btGrahamScan2dConvexHull.h
	src/LinearMath/btHashMap.h             src/LinearMath/btSerializer.h
	src/LinearMath/btIDebugDraw.h          src/LinearMath/btStackAlloc.h
	src/LinearMath/btList.h                src/LinearMath/btTransform.h
	src/LinearMath/btMatrix3x3.h           src/LinearMath/btTransformUtil.h
	src/LinearMath/btMinMax.h              src/LinearMath/btVector3.h
	)

# TODO: original comment:
# Certain g++ versions causes stk to crash if btVoronoiSimplexSolver.cpp is
# compiled with optimisations. Since it's rather difficult to specify certain
# flags for one file only with auto-tools (you can only specify flags per
# library, so you have to put this one file into a separate library) we compile
# the whole libbulletcollision with the modified flags - i.e. by adding 
# -fno-elide-constructors to the flags. The overall performance impact is
# quite low anyway.

# libbulletcollision
add_library(bulletcollision STATIC
	src/BulletCollision/BroadphaseCollision/btAxisSweep3.cpp
	src/BulletCollision/BroadphaseCollision/btAxisSweep3.h
	src/BulletCollision/BroadphaseCollision/btBroadphaseInterface.h
	src/BulletCollision/BroadphaseCollision/btBroadphaseProxy.cpp
	src/BulletCollision/BroadphaseCollision/btBroadphaseProxy.h
	src/BulletCollision/BroadphaseCollision/btCollisionAlgorithm.cpp
	src/BulletCollision/BroadphaseCollision/btCollisionAlgorithm.h
	src/BulletCollision/BroadphaseCollision/btDbvtBroadphase.cpp
	src/BulletCollision/BroadphaseCollision/btDbvtBroadphase.h
	src/BulletCollision/BroadphaseCollision/btDbvt.cpp
	src/BulletCollision/BroadphaseCollision/btDbvt.h
	src/BulletCollision/BroadphaseCollision/btDispatcher.cpp
	src/BulletCollision/BroadphaseCollision/btDispatcher.h
	src/BulletCollision/BroadphaseCollision/btMultiSapBroadphase.cpp
	src/BulletCollision/BroadphaseCollision/btMultiSapBroadphase.h
	src/BulletCollision/BroadphaseCollision/btOverlappingPairCache.cpp
	src/BulletCollision/BroadphaseCollision/btOverlappingPairCache.h
	src/BulletCollision/BroadphaseCollision/btOverlappingPairCallback.h
	src/BulletCollision/BroadphaseCollision/btQuantizedBvh.cpp
	src/BulletCollision/BroadphaseCollision/btQuantizedBvh.h
	src/BulletCollision/BroadphaseCollision/btSimpleBroadphase.cpp
	src/BulletCollision/BroadphaseCollision/btSimpleBroadphase.h
	src/BulletCollision/CollisionDispatch/btActivatingCollisionAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btActivatingCollisionAlgorithm.h
	src/BulletCollision/CollisionDispatch/btBox2dBox2dCollisionAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btBox2dBox2dCollisionAlgorithm.h
	src/BulletCollision/CollisionDispatch/btBoxBoxCollisionAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btBoxBoxCollisionAlgorithm.h
	src/BulletCollision/CollisionDispatch/btBoxBoxDetector.cpp
	src/BulletCollision/CollisionDispatch/btBoxBoxDetector.h
	src/BulletCollision/CollisionDispatch/btCollisionConfiguration.h
	src/BulletCollision/CollisionDispatch/btCollisionCreateFunc.h
	src/BulletCollision/CollisionDispatch/btCollisionDispatcher.cpp
	src/BulletCollision/CollisionDispatch/btCollisionDispatcher.h
	src/BulletCollision/CollisionDispatch/btCollisionObject.cpp
	src/BulletCollision/CollisionDispatch/btCollisionObject.h
	src/BulletCollision/CollisionDispatch/btCollisionWorld.cpp
	src/BulletCollision/CollisionDispatch/btCollisionWorld.h
	src/BulletCollision/CollisionDispatch/btCompoundCollisionAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btCompoundCollisionAlgorithm.h
	src/BulletCollision/CollisionDispatch/btConvex2dConvex2dAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btConvex2dConvex2dAlgorithm.h
	src/BulletCollision/CollisionDispatch/btConvexConcaveCollisionAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btConvexConcaveCollisionAlgorithm.h
	src/BulletCollision/CollisionDispatch/btConvexConvexAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btConvexConvexAlgorithm.h
	src/BulletCollision/CollisionDispatch/btConvexPlaneCollisionAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btConvexPlaneCollisionAlgorithm.h
	src/BulletCollision/CollisionDispatch/btDefaultCollisionConfiguration.cpp
	src/BulletCollision/CollisionDispatch/btDefaultCollisionConfiguration.h
	src/BulletCollision/CollisionDispatch/btEmptyCollisionAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btEmptyCollisionAlgorithm.h
	src/BulletCollision/CollisionDispatch/btGhostObject.cpp
	src/BulletCollision/CollisionDispatch/btGhostObject.h
	src/BulletCollision/CollisionDispatch/btInternalEdgeUtility.cpp
	src/BulletCollision/CollisionDispatch/btInternalEdgeUtility.h
	src/BulletCollision/CollisionDispatch/btManifoldResult.cpp
	src/BulletCollision/CollisionDispatch/btManifoldResult.h
	src/BulletCollision/CollisionDispatch/btSimulationIslandManager.cpp
	src/BulletCollision/CollisionDispatch/btSimulationIslandManager.h
	src/BulletCollision/CollisionDispatch/btSphereBoxCollisionAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btSphereBoxCollisionAlgorithm.h
	src/BulletCollision/CollisionDispatch/btSphereSphereCollisionAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btSphereSphereCollisionAlgorithm.h
	src/BulletCollision/CollisionDispatch/btSphereTriangleCollisionAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btSphereTriangleCollisionAlgorithm.h
	src/BulletCollision/CollisionDispatch/btUnionFind.cpp
	src/BulletCollision/CollisionDispatch/btUnionFind.h
	src/BulletCollision/CollisionDispatch/SphereTriangleDetector.cpp
	src/BulletCollision/CollisionDispatch/SphereTriangleDetector.h
	src/BulletCollision/CollisionShapes/btBox2dShape.cpp
	src/BulletCollision/CollisionShapes/btBox2dShape.h
	src/BulletCollision/CollisionShapes/btBoxShape.cpp
	src/BulletCollision/CollisionShapes/btBoxShape.h
	src/BulletCollision/CollisionShapes/btBvhTriangleMeshShape.cpp
	src/BulletCollision/CollisionShapes/btBvhTriangleMeshShape.h
	src/BulletCollision/CollisionShapes/btCapsuleShape.cpp
	src/BulletCollision/CollisionShapes/btCapsuleShape.h
	src/BulletCollision/CollisionShapes/btCollisionMargin.h
	src/BulletCollision/CollisionShapes/btCollisionShape.cpp
	src/BulletCollision/CollisionShapes/btCollisionShape.h
	src/BulletCollision/CollisionShapes/btCompoundShape.cpp
	src/BulletCollision/CollisionShapes/btCompoundShape.h
	src/BulletCollision/CollisionShapes/btConcaveShape.cpp
	src/BulletCollision/CollisionShapes/btConcaveShape.h
	src/BulletCollision/CollisionShapes/btConeShape.cpp
	src/BulletCollision/CollisionShapes/btConeShape.h
	src/BulletCollision/CollisionShapes/btConvex2dShape.cpp
	src/BulletCollision/CollisionShapes/btConvex2dShape.h
	src/BulletCollision/CollisionShapes/btConvexHullShape.cpp
	src/BulletCollision/CollisionShapes/btConvexHullShape.h
	src/BulletCollision/CollisionShapes/btConvexInternalShape.cpp
	src/BulletCollision/CollisionShapes/btConvexInternalShape.h
	src/BulletCollision/CollisionShapes/btConvexPointCloudShape.cpp
	src/BulletCollision/CollisionShapes/btConvexPointCloudShape.h
	src/BulletCollision/CollisionShapes/btConvexPolyhedron.cpp
	src/BulletCollision/CollisionShapes/btConvexPolyhedron.h
	src/BulletCollision/CollisionShapes/btConvexShape.cpp
	src/BulletCollision/CollisionShapes/btConvexShape.h
	src/BulletCollision/CollisionShapes/btConvexTriangleMeshShape.cpp
	src/BulletCollision/CollisionShapes/btConvexTriangleMeshShape.h
	src/BulletCollision/CollisionShapes/btCylinderShape.cpp
	src/BulletCollision/CollisionShapes/btCylinderShape.h
	src/BulletCollision/CollisionShapes/btEmptyShape.cpp
	src/BulletCollision/CollisionShapes/btEmptyShape.h
	src/BulletCollision/CollisionShapes/btHeightfieldTerrainShape.cpp
	src/BulletCollision/CollisionShapes/btHeightfieldTerrainShape.h
	src/BulletCollision/CollisionShapes/btMaterial.h
	src/BulletCollision/CollisionShapes/btMinkowskiSumShape.cpp
	src/BulletCollision/CollisionShapes/btMinkowskiSumShape.h
	src/BulletCollision/CollisionShapes/btMultimaterialTriangleMeshShape.cpp
	src/BulletCollision/CollisionShapes/btMultimaterialTriangleMeshShape.h
	src/BulletCollision/CollisionShapes/btMultiSphereShape.cpp
	src/BulletCollision/CollisionShapes/btMultiSphereShape.h
	src/BulletCollision/CollisionShapes/btOptimizedBvh.cpp
	src/BulletCollision/CollisionShapes/btOptimizedBvh.h
	src/BulletCollision/CollisionShapes/btPolyhedralConvexShape.cpp
	src/BulletCollision/CollisionShapes/btPolyhedralConvexShape.h
	src/BulletCollision/CollisionShapes/btScaledBvhTriangleMeshShape.cpp
	src/BulletCollision/CollisionShapes/btScaledBvhTriangleMeshShape.h
	src/BulletCollision/CollisionShapes/btShapeHull.cpp
	src/BulletCollision/CollisionShapes/btShapeHull.h
	src/BulletCollision/CollisionShapes/btSphereShape.cpp
	src/BulletCollision/CollisionShapes/btSphereShape.h
	src/BulletCollision/CollisionShapes/btStaticPlaneShape.cpp
	src/BulletCollision/CollisionShapes/btStaticPlaneShape.h
	src/BulletCollision/CollisionShapes/btStridingMeshInterface.cpp
	src/BulletCollision/CollisionShapes/btStridingMeshInterface.h
	src/BulletCollision/CollisionShapes/btTetrahedronShape.cpp
	src/BulletCollision/CollisionShapes/btTetrahedronShape.h
	src/BulletCollision/CollisionShapes/btTriangleBuffer.cpp
	src/BulletCollision/CollisionShapes/btTriangleBuffer.h
	src/BulletCollision/CollisionShapes/btTriangleCallback.cpp
	src/BulletCollision/CollisionShapes/btTriangleCallback.h
	src/BulletCollision/CollisionShapes/btTriangleIndexVertexArray.cpp
	src/BulletCollision/CollisionShapes/btTriangleIndexVertexArray.h
	src/BulletCollision/CollisionShapes/btTriangleIndexVertexMaterialArray.cpp
	src/BulletCollision/CollisionShapes/btTriangleIndexVertexMaterialArray.h
	src/BulletCollision/CollisionShapes/btTriangleInfoMap.h
	src/BulletCollision/CollisionShapes/btTriangleMesh.cpp
	src/BulletCollision/CollisionShapes/btTriangleMesh.h
	src/BulletCollision/CollisionShapes/btTriangleMeshShape.cpp
	src/BulletCollision/CollisionShapes/btTriangleMeshShape.h
	src/BulletCollision/CollisionShapes/btTriangleShape.h
	src/BulletCollision/CollisionShapes/btUniformScalingShape.cpp
	src/BulletCollision/CollisionShapes/btUniformScalingShape.h
	src/BulletCollision/Gimpact/btBoxCollision.h
	src/BulletCollision/Gimpact/btClipPolygon.h
	src/BulletCollision/Gimpact/btContactProcessing.cpp
	src/BulletCollision/Gimpact/btContactProcessing.h
	src/BulletCollision/Gimpact/btGenericPoolAllocator.cpp
	src/BulletCollision/Gimpact/btGenericPoolAllocator.h
	src/BulletCollision/Gimpact/btGeometryOperations.h
	src/BulletCollision/Gimpact/btGImpactBvh.cpp
	src/BulletCollision/Gimpact/btGImpactBvh.h
	src/BulletCollision/Gimpact/btGImpactCollisionAlgorithm.cpp
	src/BulletCollision/Gimpact/btGImpactCollisionAlgorithm.h
	src/BulletCollision/Gimpact/btGImpactMassUtil.h
	src/BulletCollision/Gimpact/btGImpactQuantizedBvh.cpp
	src/BulletCollision/Gimpact/btGImpactQuantizedBvh.h
	src/BulletCollision/Gimpact/btGImpactShape.cpp
	src/BulletCollision/Gimpact/btGImpactShape.h
	src/BulletCollision/Gimpact/btQuantization.h
	src/BulletCollision/Gimpact/btTriangleShapeEx.cpp
	src/BulletCollision/Gimpact/btTriangleShapeEx.h

=== lib/enet/CMakeLists.txt ===
# CMakeLists.txt - enet

include_directories("include")

if(APPLE)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -arch x86_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -arch x86_64 -F/Library/Frameworks")
endif()

add_definitions(-DHAS_SOCKLEN_T)

add_library(enet STATIC
	callbacks.c
	compress.c
	host.c
	list.c
	packet.c
	peer.c
	protocol.c
	unix.c
	win32.c
)

if(MINGW)
  target_link_libraries(enet wsock32 ws2_32 winmm)
endif()

#if(WIN32)
#  find_library(WS2_LIBRARY NAMES "ws2_32" PATHS "C:/Windows/System32")
#  target_link_libraries(enet ${WS2_LIBRARY})
#endif()

=== lib/glew/CMakeLists.txt ===
# CMakeLists.txt - glew

if (NOT SERVER_ONLY)
include_directories("include")

if(APPLE)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -arch x86_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -arch x86_64 -F/Library/Frameworks")
endif()

find_package(OpenGL REQUIRED)
include_directories(${OPENGL_INCLUDE_DIR})

add_definitions(-DGLEW_STATIC)

add_library(glew STATIC
    include/GL/glew.h  include/GL/glxew.h  include/GL/wglew.h
    src/glew.c         src/glewinfo.c
)

target_link_libraries(glew ${OPENGL_gl_LIBRARY})

endif()

=== lib/irrlicht/CMakeLists.txt ===
# CMakeLists.txt for Irrlicht in STK
find_package(PNG REQUIRED)
find_package(JPEG REQUIRED)

include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include/"
                    "${JPEG_INCLUDE_DIR}"
                    "${PNG_INCLUDE_DIRS}"
                    "${ZLIB_INCLUDE_DIR}")

if(MSVC OR APPLE)
    include_directories("${CMAKE_CURRENT_BINARY_DIR}/../zlib/" # For zconf.h on WIN32
                        "${CMAKE_CURRENT_BINARY_DIR}/../libpng/")
endif()

if(NOT SERVER_ONLY)
    if(NOT USE_GLES2)
        find_package(OpenGL REQUIRED)
        include_directories(${OPENGL_INCLUDE_DIR})
    endif()
        
    if(UNIX AND NOT APPLE)
        find_package(X11 REQUIRED)
        include_directories(${X11_INCLUDE_DIR})
        
        if(NOT X11_FOUND)
            message(FATAL_ERROR "X11 not found.")
        endif()
        
        if(NOT X11_Xrandr_FOUND)
            message(FATAL_ERROR "XRANDR not found.")
        endif()
    endif()

    if(ENABLE_WAYLAND_DEVICE)
        find_package(Wayland REQUIRED)
        include_directories(${WAYLAND_INCLUDE_DIR})
        
        if(NOT WAYLAND_FOUND)
            message(FATAL_ERROR "Wayland not found.")
        endif()
        
        add_definitions(-D_IRR_COMPILE_WITH_WAYLAND_DEVICE_)
    endif()

    if(USE_GLES2 OR ENABLE_WAYLAND_DEVICE)
        find_package(EGL REQUIRED)
        include_directories(${EGL_INCLUDE_DIR})
        
        if(NOT EGL_FOUND)
            message(FATAL_ERROR "EGL not found.")
        endif()
    endif()
else()
    add_definitions(-DNO_IRR_COMPILE_WITH_OPENGL_)
    add_definitions(-DNO_IRR_COMPILE_WITH_X11_)
    add_definitions(-DNO_IRR_COMPILE_WITH_WAYLAND_DEVICE_)
endif()

if(APPLE)
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/source/Irrlicht/MacOSX" "${CMAKE_CURRENT_SOURCE_DIR}/source/Irrlicht")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -arch x86_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -arch x86_64 -F/Library/Frameworks")
endif()

add_definitions(-DNDEBUG=1 -DIRRLICHT_EXPORTS=1 -DPNG_THREAD_UNSAFE_OK -DPNG_NO_MMX_CODE -DPNG_NO_MNG_FEATURES)

if(UNIX OR MINGW)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++0x")
endif()

if(WIN32)
    add_definitions(-D_IRR_STATIC_LIB_)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS) # Shut up about unsafe stuff
else()
    set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS} -Wall -pipe -O3  -fno-exceptions  -fstrict-aliasing")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -pipe -O3  -fno-exceptions  -fstrict-aliasing")
    if(CMAKE_COMPILER_IS_GNUCC)
        set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS} -fexpensive-optimizations")
    endif()
    if(CMAKE_COMPILER_IS_GNUCXX)
        set(CMAKE_CXX_FLAGS   "${CMAKE_CXX_FLAGS} -fexpensive-optimizations")
    endif()
endif()

if(USE_GLES2)
    add_definitions(-D_IRR_COMPILE_WITH_OGLES2_ -DNO_IRR_COMPILE_WITH_OPENGL_)
endif()

if(CYGWIN)
    add_definitions(-DNO_IRR_COMPILE_WITH_JOYSTICK_EVENTS_)
endif()


set(IRRLICHT_SOURCES
source/Irrlicht/CAnimatedMeshSceneNode.cpp
source/Irrlicht/CAttributes.cpp
source/Irrlicht/CBillboardSceneNode.cpp
source/Irrlicht/CBoneSceneNode.cpp
source/Irrlicht/CCameraSceneNode.cpp
source/Irrlicht/CContextEGL.cpp
source/Irrlicht/CColorConverter.cpp
source/Irrlicht/CCubeSceneNode.cpp
source/Irrlicht/CDefaultGUIElementFactory.cpp
source/Irrlicht/CDefaultSceneNodeAnimatorFactory.cpp
source/Irrlicht/CDefaultSceneNodeFactory.cpp
source/Irrlicht/CDummyTransformationSceneNode.cpp
source/Irrlicht/CEmptySceneNode.cpp
source/Irrlicht/CFileList.cpp
source/Irrlicht/CFileSystem.cpp
source/Irrlicht/CFPSCounter.cpp
source/Irrlicht/CGeometryCreator.cpp
source/Irrlicht/CGUIButton.cpp
source/Irrlicht/CGUICheckBox.cpp
source/Irrlicht/CGUIColorSelectDialog.cpp
source/Irrlicht/CGUIComboBox.cpp
source/Irrlicht/CGUIContextMenu.cpp
source/Irrlicht/CGUIEditBox.cpp
source/Irrlicht/CGUIEnvironment.cpp
source/Irrlicht/CGUIFileOpenDialog.cpp
source/Irrlicht/CGUIFont.cpp
source/Irrlicht/CGUIImage.cpp
source/Irrlicht/CGUIImageList.cpp
source/Irrlicht/CGUIInOutFader.cpp
source/Irrlicht/CGUIListBox.cpp
source/Irrlicht/CGUIMenu.cpp
source/Irrlicht/CGUIMeshViewer.cpp
source/Irrlicht/CGUIMessageBox.cpp
source/Irrlicht/CGUIModalScreen.cpp
source/Irrlicht/CGUIScrollBar.cpp
source/Irrlicht/CGUISkin.cpp
source/Irrlicht/CGUISpinBox.cpp
source/Irrlicht/CGUISpriteBank.cpp
source/Irrlicht/CGUIStaticText.cpp
source/Irrlicht/CGUITabControl.cpp
source/Irrlicht/CGUITable.cpp
source/Irrlicht/CGUIToolBar.cpp
source/Irrlicht/CGUITreeView.cpp
source/Irrlicht/CGUIWindow.cpp
source/Irrlicht/CImage.cpp
source/Irrlicht/CImageLoaderBMP.cpp
source/Irrlicht/CImageLoaderJPG.cpp
source/Irrlicht/CImageLoaderPNG.cpp
source/Irrlicht/CImageWriterBMP.cpp
source/Irrlicht/CImageWriterJPG.cpp
source/Irrlicht/CImageWriterPNG.cpp
source/Irrlicht/CIrrDeviceAndroid.cpp
source/Irrlicht/CIrrDeviceLinux.cpp
source/Irrlicht/CIrrDeviceSDL.cpp
source/Irrlicht/CIrrDeviceStub.cpp
source/Irrlicht/CIrrDeviceWayland.cpp
source/Irrlicht/CIrrDeviceWin32.cpp
source/Irrlicht/CLightSceneNode.cpp
source/Irrlicht/CLimitReadFile.cpp
source/Irrlicht/CLogger.cpp
source/Irrlicht/CMemoryFile.cpp
source/Irrlicht/CMeshCache.cpp
source/Irrlicht/CMeshManipulator.cpp
source/Irrlicht/CMeshSceneNode.cpp
source/Irrlicht/CMetaTriangleSelector.cpp
source/Irrlicht/CMountPointReader.cpp
source/Irrlicht/CNullDriver.cpp
source/Irrlicht/COctreeSceneNode.cpp
source/Irrlicht/COctreeTriangleSelector.cpp
source/Irrlicht/COGLES2Driver.cpp
source/Irrlicht/COGLES2ExtensionHandler.cpp
source/Irrlicht/COGLES2FixedPipelineRenderer.cpp
source/Irrlicht/COGLES2MaterialRenderer.cpp
source/Irrlicht/COGLES2NormalMapRenderer.cpp
source/Irrlicht/COGLES2ParallaxMapRenderer.cpp
source/Irrlicht/COGLES2Renderer2D.cpp
source/Irrlicht/COGLES2Texture.cpp
source/Irrlicht/COpenGLDriver.cpp
source/Irrlicht/COpenGLExtensionHandler.cpp
source/Irrlicht/COpenGLParallaxMapRenderer.cpp
source/Irrlicht/COpenGLShaderMaterialRenderer.cpp
source/Irrlicht/COpenGLSLMaterialRenderer.cpp
source/Irrlicht/COpenGLTexture.cpp
source/Irrlicht/COSOperator.cpp
source/Irrlicht/CParticleAnimatedMeshSceneNodeEmitter.cpp
source/Irrlicht/CParticleAttractionAffector.cpp
source/Irrlicht/CParticleBoxEmitter.cpp
source/Irrlicht/CParticleCylinderEmitter.cpp
source/Irrlicht/CParticleFadeOutAffector.cpp
source/Irrlicht/CParticleGravityAffector.cpp
source/Irrlicht/CParticleMeshEmitter.cpp
source/Irrlicht/CParticlePointEmitter.cpp
source/Irrlicht/CParticleRingEmitter.cpp
source/Irrlicht/CParticleRotationAffector.cpp
source/Irrlicht/CParticleScaleAffector.cpp
source/Irrlicht/CParticleSphereEmitter.cpp
source/Irrlicht/CParticleSystemSceneNode.cpp
source/Irrlicht/CReadFile.cpp
source/Irrlicht/CSceneCollisionManager.cpp
source/Irrlicht/CSceneManager.cpp
source/Irrlicht/CSceneNodeAnimatorCameraFPS.cpp
source/Irrlicht/CSceneNodeAnimatorCameraMaya.cpp
source/Irrlicht/CSceneNodeAnimatorCollisionResponse.cpp
source/Irrlicht/CSceneNodeAnimatorDelete.cpp
source/Irrlicht/CSceneNodeAnimatorFlyCircle.cpp
source/Irrlicht/CSceneNodeAnimatorFlyStraight.cpp
source/Irrlicht/CSceneNodeAnimatorFollowSpline.cpp
source/Irrlicht/CSceneNodeAnimatorRotation.cpp
source/Irrlicht/CSceneNodeAnimatorTexture.cpp
source/Irrlicht/CSkinnedMesh.cpp
source/Irrlicht/CSkyBoxSceneNode.cpp
source/Irrlicht/CSkyDomeSceneNode.cpp
source/Irrlicht/CSphereSceneNode.cpp
source/Irrlicht/CTarReader.cpp
source/Irrlicht/CTerrainSceneNode.cpp
source/Irrlicht/CTerrainTriangleSelector.cpp
source/Irrlicht/CTextSceneNode.cpp
source/Irrlicht/CTriangleBBSelector.cpp
source/Irrlicht/CTriangleSelector.cpp
source/Irrlicht/CVideoModeList.cpp
source/Irrlicht/CWaterSurfaceSceneNode.cpp
source/Irrlicht/CWriteFile.cpp
source/Irrlicht/CXMLReader.cpp
source/Irrlicht/CXMLWriter.cpp
source/Irrlicht/CZBuffer.cpp
source/Irrlicht/CZipReader.cpp
source/Irrlicht/Irrlicht.cpp
source/Irrlicht/irrXML.cpp
source/Irrlicht/os.cpp
source/Irrlicht/COpenGLNormalMapRenderer.cpp
source/Irrlicht/CAnimatedMeshSceneNode.h
source/Irrlicht/CAttributeImpl.h
source/Irrlicht/CAttributes.h
source/Irrlicht/CBillboardSceneNode.h
source/Irrlicht/CBlit.h
source/Irrlicht/CBoneSceneNode.h
source/Irrlicht/CCameraSceneNode.h
source/Irrlicht/CContextEGL.h
source/Irrlicht/CColorConverter.h
source/Irrlicht/CCubeSceneNode.h
source/Irrlicht/CDefaultGUIElementFactory.h
source/Irrlicht/CDefaultSceneNodeAnimatorFactory.h
source/Irrlicht/CDefaultSceneNodeFactory.h
source/Irrlicht/CDummyTransformationSceneNode.h
source/Irrlicht/CEmptySceneNode.h
source/Irrlicht/CFileList.h
source/Irrlicht/CFileSystem.h
source/Irrlicht/CFPSCounter.h
source/Irrlicht/CGeometryCreator.h
source/Irrlicht/CGUIButton.h
source/Irrlicht/CGUICheckBox.h
source/Irrlicht/CGUIColorSelectDialog.h
source/Irrlicht/CGUIComboBox.h
source/Irrlicht/CGUIContextMenu.h
source/Irrlicht/CGUIEditBox.h
source/Irrlicht/CGUIEnvironment.h
source/Irrlicht/CGUIFileOpenDialog.h
source/Irrlicht/CGUIFont.h
source/Irrlicht/CGUIImage.h
source/Irrlicht/CGUIImageList.h
source/Irrlicht/CGUIInOutFader.h
source/Irrlicht/CGUIListBox.h
source/Irrlicht/CGUIMenu.h
source/Irrlicht/CGUIMeshViewer.h
source/Irrlicht/CGUIMessageBox.h
source/Irrlicht/CGUIModalScreen.h
source/Irrlicht/CGUIScrollBar.h
source/Irrlicht/CGUISkin.h
source/Irrlicht/CGUISpinBox.h
source/Irrlicht/CGUISpriteBank.h
source/Irrlicht/CGUIStaticText.h
source/Irrlicht/CGUITabControl.h
source/Irrlicht/CGUITable.h
source/Irrlicht/CGUIToolBar.h
source/Irrlicht/CGUITreeView.h
source/Irrlicht/CGUIWindow.h
source/Irrlicht/CImage.h
source/Irrlicht/CImageLoaderBMP.h
source/Irrlicht/CImageLoaderJPG.h
source/Irrlicht/CImageLoaderPNG.h
source/Irrlicht/CImageWriterBMP.h
source/Irrlicht/CImageWriterJPG.h
source/Irrlicht/CImageWriterPNG.h
source/Irrlicht/CIrrDeviceAndroid.h
source/Irrlicht/CIrrDeviceLinux.h
source/Irrlicht/CIrrDeviceSDL.h
source/Irrlicht/CIrrDeviceStub.h
source/Irrlicht/CIrrDeviceWayland.h
source/Irrlicht/CIrrDeviceWin32.h
source/Irrlicht/CLightSceneNode.h
source/Irrlicht/CLimitReadFile.h
source/Irrlicht/CLogger.h
source/Irrlicht/CMemoryFile.h
source/Irrlicht/CMeshCache.h
source/Irrlicht/CMeshManipulator.h
source/Irrlicht/CMeshSceneNode.h
source/Irrlicht/CMetaTriangleSelector.h
source/Irrlicht/CMountPointReader.h
source/Irrlicht/CNullDriver.h
source/Irrlicht/COctreeSceneNode.h
source/Irrlicht/COctreeTriangleSelector.h
source/Irrlicht/COGLES2Driver.h
source/Irrlicht/COGLES2ExtensionHandler.h
source/Irrlicht/COGLES2FixedPipelineRenderer.h
source/Irrlicht/COGLES2MaterialRenderer.h
source/Irrlicht/COGLES2NormalMapRenderer.h
source/Irrlicht/COGLES2ParallaxMapRenderer.h
source/Irrlicht/COGLES2Renderer2D.h
source/Irrlicht/COGLES2Texture.h
source/Irrlicht/COpenGLDriver.h
source/Irrlicht/COpenGLExtensionHandler.h
source/Irrlicht/COpenGLMaterialRenderer.h
source/Irrlicht/COpenGLParallaxMapRenderer.h
source/Irrlicht/COpenGLShaderMaterialRenderer.h
source/Irrlicht/COpenGLSLMaterialRenderer.h
source/Irrlicht/COpenGLTexture.h
source/Irrlicht/COSOperator.h
source/Irrlicht/CParticleAnimatedMeshSceneNodeEmitter.h
source/Irrlicht/CParticleAttractionAffector.h
source/Irrlicht/CParticleBoxEmitter.h
source/Irrlicht/CParticleCylinderEmitter.h
source/Irrlicht/CParticleFadeOutAffector.h
source/Irrlicht/CParticleGravityAffector.h
source/Irrlicht/CParticleMeshEmitter.h
source/Irrlicht/CParticlePointEmitter.h
source/Irrlicht/CParticleRingEmitter.h
source/Irrlicht/CParticleRotationAffector.h
source/Irrlicht/CParticleScaleAffector.h
source/Irrlicht/CParticleSphereEmitter.h
source/Irrlicht/CParticleSystemSceneNode.h
source/Irrlicht/CReadFile.h
source/Irrlicht/CSceneCollisionManager.h
source/Irrlicht/CSceneManager.h
source/Irrlicht/CSceneNodeAnimatorCameraFPS.h
source/Irrlicht/CSceneNodeAnimatorCameraMaya.h
source/Irrlicht/CSceneNodeAnimatorCollisionResponse.h
source/Irrlicht/CSceneNodeAnimatorDelete.h
source/Irrlicht/CSceneNodeAnimatorFlyCircle.h
source/Irrlicht/CSceneNodeAnimatorFlyStraight.h
source/Irrlicht/CSceneNodeAnimatorFollowSpline.h
source/Irrlicht/CSceneNodeAnimatorRotation.h
source/Irrlicht/CSceneNodeAnimatorTexture.h
source/Irrlicht/CSkinnedMesh.h
source/Irrlicht/CSkyBoxSceneNode.h

=== lib/jpeglib/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.4.4)

if(APPLE)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -arch x86_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -arch x86_64 -F/Library/Frameworks")
endif()

SET(JPEG_SRCS
 jaricom.c
 jcapimin.c
 jcapistd.c
 jcarith.c
 jccoefct.c
 jccolor.c
 jcdctmgr.c
 jchuff.c
 jcinit.c
 jcmainct.c
 jcmarker.c
 jcmaster.c
 jcomapi.c
 jcparam.c
 jcprepct.c
 jcsample.c
 jctrans.c
 jdapimin.c
 jdapistd.c
 jdarith.c
 jdatadst.c
 jdatasrc.c
 jdcoefct.c
 jdcolor.c
 jddctmgr.c
 jdhuff.c
 jdinput.c
 jdmainct.c
 jdmarker.c
 jdmaster.c
 jdmerge.c
 jdpostct.c
 jdsample.c
 jdtrans.c
 jerror.c
 jfdctflt.c
 jfdctfst.c
 jfdctint.c
 jidctflt.c
 jidctfst.c
 jidctint.c
 jmemmgr.c
 jmemnobs.c
 jquant1.c
 jquant2.c
 jutils.c)

add_library(jpeglib STATIC ${JPEG_SRCS})

=== lib/libpng/CMakeLists.txt ===
# CMakeLists.txt

# Copyright (C) 2007,2009-2016 Glenn Randers-Pehrson
# Written by Christian Ehrlicher, 2007
# Revised by Roger Lowman, 2009-2010
# Revised by Clifford Yapp, 2011-2012
# Revised by Roger Leigh, 2016

# This code is released under the libpng license.
# For conditions of distribution and use, see the disclaimer
# and license in png.h

cmake_minimum_required(VERSION 2.8.3)
cmake_policy(VERSION 2.8.3)

# Set MacOSX @rpath usage globally.
if (POLICY CMP0020)
  cmake_policy(SET CMP0020 NEW)
endif(POLICY CMP0020)
if (POLICY CMP0042)
  cmake_policy(SET CMP0042 NEW)
endif(POLICY CMP0042)
# Use new variable expansion policy.
if (POLICY CMP0053)
  cmake_policy(SET CMP0053 NEW)
endif(POLICY CMP0053)
if (POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW)
endif(POLICY CMP0054)

set(CMAKE_CONFIGURATION_TYPES "Release;Debug;MinSizeRel;RelWithDebInfo")

enable_testing()

set(PNGLIB_MAJOR 1)
set(PNGLIB_MINOR 5)
set(PNGLIB_RELEASE 28)
set(PNGLIB_NAME libpng${PNGLIB_MAJOR}${PNGLIB_MINOR})
set(PNGLIB_VERSION ${PNGLIB_MAJOR}.${PNGLIB_MINOR}.${PNGLIB_RELEASE})


# Needed packages. Since WIN32 (except mingw) uses the included zlib
# version, find_package would fail with an error message. Since
# all variables are already set in this case, the find package
# is actually not necessary in this case, so just ignore it
if(NOT WIN32 OR MINGW)
    find_package(ZLIB REQUIRED)
    include_directories(${ZLIB_INCLUDE_DIR})
endif()

if(NOT WIN32)
  find_library(M_LIBRARY
    NAMES m
    PATHS /usr/lib /usr/local/lib
  )
  if(NOT M_LIBRARY)
    message(STATUS "math lib 'libm' not found; floating point support disabled")
    set(M_LIBRARY "")
  endif()
else()
  # not needed on windows
  set(M_LIBRARY "")
endif()

# COMMAND LINE OPTIONS
option(PNG_SHARED "Build shared lib" ON)
option(PNG_STATIC "Build static lib" ON)
option(PNG_TESTS  "Build libpng tests" ON)

# Many more configuration options could be added here
option(PNG_FRAMEWORK "Build OS X framework" OFF)
option(PNG_DEBUG     "Build with debug output" OFF)
option(PNGARG        "Disable ANSI-C prototypes" OFF)

set(DFA_XTRA "" CACHE FILEPATH "File containing extra configuration settings")

# SET LIBNAME
set(PNG_LIB_NAME png${PNGLIB_MAJOR}${PNGLIB_MINOR})

# to distinguish between debug and release lib
set(CMAKE_DEBUG_POSTFIX "d")

include(CheckCSourceCompiles)
option(ld-version-script "Enable linker version script" ON)
if(ld-version-script AND NOT APPLE)
  # Check if LD supports linker scripts.
  file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/conftest.map" "VERS_1 {
        global: sym;
        local: *;
};

VERS_2 {
        global: sym2;
                main;
} VERS_1;
")
  set(CMAKE_REQUIRED_FLAGS_SAVE ${CMAKE_REQUIRED_FLAGS})
  set(CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS} "-Wl,--version-script='${CMAKE_CURRENT_BINARY_DIR}/conftest.map'")
  check_c_source_compiles("void sym(void) {}
void sym2(void) {}
int main(void) {return 0;}
" HAVE_LD_VERSION_SCRIPT)
  if(NOT HAVE_LD_VERSION_SCRIPT)
    set(CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS_SAVE} "-Wl,-M -Wl,${CMAKE_CURRENT_BINARY_DIR}/conftest.map")
  check_c_source_compiles("void sym(void) {}
void sym2(void) {}
int main(void) {return 0;}
" HAVE_SOLARIS_LD_VERSION_SCRIPT)
  endif()
  set(CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS_SAVE})
  file(REMOVE "${CMAKE_CURRENT_BINARY_DIR}/conftest.map")
endif()

find_program(AWK NAMES gawk awk)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

if(NOT AWK)
  # No awk available to generate sources; use pre-built pnglibconf.h
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/scripts/pnglibconf.h.prebuilt
                 ${CMAKE_CURRENT_BINARY_DIR}/pnglibconf.h)
  add_custom_target(genfiles) # Dummy
else()
  include(CMakeParseArguments)
  # Generate .chk from .out with awk
  # generate_chk(INPUT inputfile OUTPUT outputfile [DEPENDS dep1 [dep2...]])
  function(generate_chk)
    set(options)
    set(oneValueArgs INPUT OUTPUT)
    set(multiValueArgs DEPENDS)
    cmake_parse_arguments(_GC "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})
    if (NOT _GC_INPUT)
      message(FATAL_ERROR "Invalid arguments.  generate_out requires input.")
    endif()
    if (NOT _GC_OUTPUT)
      message(FATAL_ERROR "Invalid arguments.  generate_out requires output.")
    endif()

    add_custom_command(OUTPUT "${_GC_OUTPUT}"
                       COMMAND "${CMAKE_COMMAND}"
                               "-DINPUT=${_GC_INPUT}"
                               "-DOUTPUT=${_GC_OUTPUT}"
                               -P "${CMAKE_CURRENT_BINARY_DIR}/scripts/genchk.cmake"
                       DEPENDS "${_GC_INPUT}" ${_GC_DEPENDS}
                       WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
  endfunction()

  # Generate .out from .c with awk
  # generate_out(INPUT inputfile OUTPUT outputfile [DEPENDS dep1 [dep2...]])
  function(generate_out)
    set(options)
    set(oneValueArgs INPUT OUTPUT)
    set(multiValueArgs DEPENDS)
    cmake_parse_arguments(_GO "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})
    if (NOT _GO_INPUT)
      message(FATAL_ERROR "Invalid arguments.  generate_out requires input.")
    endif()
    if (NOT _GO_OUTPUT)
      message(FATAL_ERROR "Invalid arguments.  generate_out requires output.")
    endif()

    add_custom_command(OUTPUT "${_GO_OUTPUT}"
                       COMMAND "${CMAKE_COMMAND}"
                               "-DINPUT=${_GO_INPUT}"
                               "-DOUTPUT=${_GO_OUTPUT}"
                               -P "${CMAKE_CURRENT_BINARY_DIR}/scripts/genout.cmake"
                       DEPENDS "${_GO_INPUT}" ${_GO_DEPENDS}
                       WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
  endfunction()

  # Generate specific source file with awk
  # generate_source(OUTPUT outputfile [DEPENDS dep1 [dep2...]])
  function(generate_source)
    set(options)
    set(oneValueArgs OUTPUT)
    set(multiValueArgs DEPENDS)
    cmake_parse_arguments(_GSO "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})
    if (NOT _GSO_OUTPUT)
      message(FATAL_ERROR "Invalid arguments.  generate_source requires output.")
    endif()

    add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${_GSO_OUTPUT}"
                       COMMAND "${CMAKE_COMMAND}"
                               "-DOUTPUT=${_GSO_OUTPUT}"
                               -P "${CMAKE_CURRENT_BINARY_DIR}/scripts/gensrc.cmake"
                       DEPENDS ${_GSO_DEPENDS}
                       WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
  endfunction()

  # Copy file
  function(generate_copy source destination)
    add_custom_command(OUTPUT "${destination}"
                       COMMAND "${CMAKE_COMMAND}" -E remove "${destination}"
                       COMMAND "${CMAKE_COMMAND}" -E copy "${source}"
                                                          "${destination}"
                       DEPENDS "${source}")
  endfunction()

  # Generate scripts/pnglibconf.h
  generate_source(OUTPUT "scripts/pnglibconf.c"
                  DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/scripts/pnglibconf.dfa"
                          "${CMAKE_CURRENT_SOURCE_DIR}/scripts/options.awk"
                          "${CMAKE_CURRENT_SOURCE_DIR}/pngconf.h")

  # Generate pnglibconf.c
  generate_source(OUTPUT "pnglibconf.c"
                  DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/scripts/pnglibconf.dfa"
                          "${CMAKE_CURRENT_SOURCE_DIR}/scripts/options.awk"
                          "${CMAKE_CURRENT_SOURCE_DIR}/pngconf.h")

  generate_out(INPUT "${CMAKE_CURRENT_BINARY_DIR}/pnglibconf.c"
               OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/pnglibconf.out")

  # Generate pnglibconf.h
  generate_source(OUTPUT "pnglibconf.h"
                  DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/pnglibconf.out"
                          ${PNGLIBCONF_H_EXTRA_DEPENDS})

  generate_out(INPUT "${CMAKE_CURRENT_SOURCE_DIR}/scripts/sym.c"
               OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/scripts/sym.out"
               DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/pnglibconf.h")

  generate_out(INPUT "${CMAKE_CURRENT_SOURCE_DIR}/scripts/symbols.c"
               OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/scripts/symbols.out"
               DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/png.h"
                       "${CMAKE_CURRENT_SOURCE_DIR}/pngconf.h"
                       "${CMAKE_CURRENT_SOURCE_DIR}/scripts/pnglibconf.h.prebuilt")

  generate_out(INPUT "${CMAKE_CURRENT_SOURCE_DIR}/scripts/vers.c"
               OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/scripts/vers.out"
               DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/png.h"
                       "${CMAKE_CURRENT_SOURCE_DIR}/pngconf.h"
                       "${CMAKE_CURRENT_BINARY_DIR}/pnglibconf.h")

  generate_chk(INPUT "${CMAKE_CURRENT_BINARY_DIR}/scripts/symbols.out"
               OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/scripts/symbols.chk"
               DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/scripts/checksym.awk"
                       "${CMAKE_CURRENT_SOURCE_DIR}/scripts/symbols.def")

  add_custom_target(symbol-check DEPENDS
                    "${CMAKE_CURRENT_BINARY_DIR}/scripts/symbols.chk")

  generate_copy("${CMAKE_CURRENT_BINARY_DIR}/scripts/sym.out"
                "${CMAKE_CURRENT_BINARY_DIR}/libpng.sym")
  generate_copy("${CMAKE_CURRENT_BINARY_DIR}/scripts/vers.out"
                "${CMAKE_CURRENT_BINARY_DIR}/libpng.vers")

  add_custom_target(genvers DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/libpng.vers")
  add_custom_target(gensym DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/libpng.sym")

  add_custom_target("genprebuilt"
                    COMMAND "${CMAKE_COMMAND}"
                            "-DOUTPUT=scripts/pnglibconf.h.prebuilt"
                            -P "${CMAKE_CURRENT_BINARY_DIR}/scripts/gensrc.cmake"
                    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

  # A single target handles generation of all generated files.  If
  # they are dependend upon separately by multiple targets, this
  # confuses parallel make (it would require a separate top-level
  # target for each file to track the dependencies properly).
  add_custom_target(genfiles DEPENDS
    "${CMAKE_CURRENT_BINARY_DIR}/libpng.sym"
    "${CMAKE_CURRENT_BINARY_DIR}/libpng.vers"
    "${CMAKE_CURRENT_BINARY_DIR}/pnglibconf.c"
    "${CMAKE_CURRENT_BINARY_DIR}/pnglibconf.h"
    "${CMAKE_CURRENT_BINARY_DIR}/pnglibconf.out"
    "${CMAKE_CURRENT_BINARY_DIR}/scripts/pnglibconf.c"
    "${CMAKE_CURRENT_BINARY_DIR}/scripts/sym.out"
    "${CMAKE_CURRENT_BINARY_DIR}/scripts/symbols.chk"
    "${CMAKE_CURRENT_BINARY_DIR}/scripts/symbols.out"
    "${CMAKE_CURRENT_BINARY_DIR}/scripts/vers.out")
endif(NOT AWK)

# OUR SOURCES
set(libpng_public_hdrs
  png.h
  pngconf.h
  "${CMAKE_CURRENT_BINARY_DIR}/pnglibconf.h"
)
set(libpng_private_hdrs
  pngpriv.h
  pngdebug.h
  pnginfo.h
  pngstruct.h
)
set(libpng_sources
  ${libpng_public_hdrs}
  ${libpng_private_hdrs}
  png.c
  pngerror.c
  pngget.c
  pngmem.c
  pngpread.c
  pngread.c
  pngrio.c
  pngrtran.c
  pngrutil.c
  pngset.c
  pngtrans.c
  pngwio.c
  pngwrite.c
  pngwtran.c
  pngwutil.c
)
set(pngtest_sources
  pngtest.c
)
set(pngvalid_sources
  contrib/libtests/pngvalid.c
)

if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
endif(MSVC)

if(PNG_DEBUG)
  add_definitions(-DPNG_DEBUG)
endif()

# NOW BUILD OUR TARGET
include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${ZLIB_INCLUDE_DIR})

unset(PNG_LIB_TARGETS)

if(PNG_SHARED)
  add_library(png SHARED ${libpng_sources})
  set(PNG_LIB_TARGETS png)
  set_target_properties(png PROPERTIES OUTPUT_NAME ${PNG_LIB_NAME})
  add_dependencies(png genfiles)
  if(MSVC)
    # msvc does not append 'lib' - do it here to have consistent name
    set_target_properties(png PROPERTIES PREFIX "lib")
    set_target_properties(png PROPERTIES IMPORT_PREFIX "lib")
  endif()
  target_link_libraries(png ${ZLIB_LIBRARY} ${M_LIBRARY})

  if(UNIX AND AWK)
    if(HAVE_LD_VERSION_SCRIPT)
      set_target_properties(png PROPERTIES LINK_FLAGS
        "-Wl,--version-script='${CMAKE_CURRENT_BINARY_DIR}/libpng.vers'")

=== lib/wiiuse/CMakeLists.txt ===
# CMakeLists.txt - wiiuse

cmake_minimum_required(VERSION 2.8.1)

# libbluetooth is required on Unix platforms
if(UNIX AND (NOT APPLE))
    include(FindPkgConfig)
    pkg_check_modules(BLUETOOTH bluez)
    if(NOT BLUETOOTH_FOUND)
        message(FATAL_ERROR "Bluetooth library not found. "
            "Either install libbluetooth or disable wiiuse support with -DUSE_WIIUSE=0")
    endif()
endif()

set(WIIUSE_SOURCES
    classic.c
    dynamics.c
    events.c
    guitar_hero_3.c
    io.c
    ir.c
    motion_plus.c
    nunchuk.c
    os_nix.c
    os_win.c
    util.c
    wiiboard.c
    wiiuse.c
)

if(APPLE)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -arch x86_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -arch x86_64 -F/Library/Frameworks")
    set(WIIUSE_SOURCES ${WIIUSE_SOURCES}
        os_mac/os_mac_find.m
        os_mac/os_mac_interface.m
        os_mac/os_mac.m
    )
endif()

if(WIN32)
    add_definitions("/DWIIUSE_STATIC")
    add_library(wiiuse STATIC ${WIIUSE_SOURCES})
else()
    add_library(wiiuse ${WIIUSE_SOURCES})
endif()

if(MSVC)
    if(MSVC90)
        set(WIIUSE_VS_INCLUDE_DIR "C:\\Program\ Files\ (x86)\\Microsoft\ Visual\ Studio\ 9.0\\VC\\include"
            CACHE STRING "VS 9.0 include directory, see lib/wiiuse/README for details")
    elseif(MSVC10)
        set(WIIUSE_VS_INCLUDE_DIR "C:\\Program\ Files\ (x86)\\Microsoft\ Visual\ Studio\ 10.0\\VC\\include"
            CACHE STRING "VS 10.0 include directory, see lib/wiiuse/README for details")
    endif()
    mark_as_advanced(WIIUSE_VS_INCLUDE_DIR)
 
    if(MSVC90 OR MSVC10)
         # VS 9 does not have the windows device driver kit
         # So the driver must be installed additionally. Also, 
         # in order to avoid a compilation error, you have to
         # specify the visual studio include path FIRST (google
         # it, known issue). So in this case add appropriate
         # variables that can be set.
         set(WIIUSE_WINDDK_ROOT "C:/WinDDK" CACHE 
             STRING "Install directory of Windows Driver Kits")
         mark_as_advanced(WIIUSE_WINDDK_ROOT)
         include_directories(${WIIUSE_VS_INCLUDE_DIR} ${WIIUSE_WINDDK_ROOT}/inc/api)
    endif()
    add_library(setupapi.lib STATIC IMPORTED)
    add_library(hid.lib STATIC IMPORTED)
    set_target_properties(setupapi.lib PROPERTIES 
                          IMPORTED_LOCATION ${WIIUSE_WINDDK_ROOT}/lib/win7/i386/setupapi.lib)
    set_target_properties(hid.lib PROPERTIES 
                          IMPORTED_LOCATION ${WIIUSE_WINDDK_ROOT}/lib/win7/i386/hid.lib)
    # This doesn't work for me with VS 11, which apparently finds its own
    # copy of the libs
    if(MSVC90 OR MSVC10)
        set_target_properties(wiiuse PROPERTIES STATIC_LIBRARY_FLAGS 
            "${WIIUSE_WINDDK_ROOT}/lib/win7/i386/setupapi.lib ${WIIUSE_WINDDK_ROOT}/lib/win7/i386/hid.lib")
    else()
        set_target_properties(wiiuse PROPERTIES STATIC_LIBRARY_FLAGS "setupapi.lib hid.lib")
    endif()
elseif(MINGW)
    target_link_libraries(wiiuse hid setupapi)
endif()

=== lib/zlib/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.4.4)
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS ON)

set(VERSION "1.2.7")

set(INSTALL_BIN_DIR "${CMAKE_INSTALL_PREFIX}/bin" CACHE PATH "Installation directory for executables")
set(INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib" CACHE PATH "Installation directory for libraries")
set(INSTALL_INC_DIR "${CMAKE_INSTALL_PREFIX}/include" CACHE PATH "Installation directory for headers")
set(INSTALL_MAN_DIR "${CMAKE_INSTALL_PREFIX}/share/man" CACHE PATH "Installation directory for manual pages")
set(INSTALL_PKGCONFIG_DIR "${CMAKE_INSTALL_PREFIX}/share/pkgconfig" CACHE PATH "Installation directory for pkgconfig (.pc) files")

include(CheckTypeSize)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCSourceCompiles)
enable_testing()

check_include_file(sys/types.h HAVE_SYS_TYPES_H)
check_include_file(stdint.h    HAVE_STDINT_H)
check_include_file(stddef.h    HAVE_STDDEF_H)

#
# Check to see if we have large file support
#
set(CMAKE_REQUIRED_DEFINITIONS -D_LARGEFILE64_SOURCE=1)
# We add these other definitions here because CheckTypeSize.cmake
# in CMake 2.4.x does not automatically do so and we want
# compatibility with CMake 2.4.x.
if(HAVE_SYS_TYPES_H)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_SYS_TYPES_H)
endif()
if(HAVE_STDINT_H)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_STDINT_H)
endif()
if(HAVE_STDDEF_H)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_STDDEF_H)
endif()
check_type_size(off64_t OFF64_T)
if(HAVE_OFF64_T)
   add_definitions(-D_LARGEFILE64_SOURCE=1)
endif()
set(CMAKE_REQUIRED_DEFINITIONS) # clear variable

#
# Check for fseeko
#
check_function_exists(fseeko HAVE_FSEEKO)
if(NOT HAVE_FSEEKO)
    add_definitions(-DNO_FSEEKO)
endif()

#
# Check for unistd.h
#
check_include_file(unistd.h Z_HAVE_UNISTD_H)

if(MSVC)
    set(CMAKE_DEBUG_POSTFIX "d")
    add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
    add_definitions(-D_CRT_NONSTDC_NO_DEPRECATE)
    include_directories(${CMAKE_CURRENT_SOURCE_DIR})
endif()

if(NOT CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
    # If we're doing an out of source build and the user has a zconf.h
    # in their source tree...
    if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/zconf.h)
        message(STATUS "Renaming")
        message(STATUS "    ${CMAKE_CURRENT_SOURCE_DIR}/zconf.h")
        message(STATUS "to 'zconf.h.included' because this file is included with zlib")
        message(STATUS "but CMake generates it automatically in the build directory.")
        file(RENAME ${CMAKE_CURRENT_SOURCE_DIR}/zconf.h ${CMAKE_CURRENT_SOURCE_DIR}/zconf.h.included)
  endif()
endif()

set(ZLIB_PC ${CMAKE_CURRENT_BINARY_DIR}/zlib.pc)
configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/zlib.pc.cmakein
		${ZLIB_PC} @ONLY)
configure_file(	${CMAKE_CURRENT_SOURCE_DIR}/zconf.h.cmakein
		${CMAKE_CURRENT_BINARY_DIR}/zconf.h @ONLY)
include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_SOURCE_DIR})


#============================================================================
# zlib
#============================================================================

set(ZLIB_PUBLIC_HDRS
    ${CMAKE_CURRENT_BINARY_DIR}/zconf.h
    zlib.h
)
set(ZLIB_PRIVATE_HDRS
    crc32.h
    deflate.h
    gzguts.h
    inffast.h
    inffixed.h
    inflate.h
    inftrees.h
    trees.h
    zutil.h
)
set(ZLIB_SRCS
    adler32.c
    compress.c
    crc32.c
    deflate.c
    gzclose.c
    gzlib.c
    gzread.c
    gzwrite.c
    inflate.c
    infback.c
    inftrees.c
    inffast.c
    trees.c
    uncompr.c
    zutil.c
)

#if(NOT MINGW)
#    set(ZLIB_SRCS ${ZLIB_SRCS}
#        win32/zlib1.rc # If present will override custom build rule below.
#    )
#endif()

# parse the full version number from zlib.h and include in ZLIB_FULL_VERSION
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/zlib.h _zlib_h_contents)
string(REGEX REPLACE ".*#define[ \t]+ZLIB_VERSION[ \t]+\"([-0-9A-Za-z.]+)\".*"
    "\\1" ZLIB_FULL_VERSION ${_zlib_h_contents})

if(MINGW)
    # This gets us DLL resource information when compiling on MinGW.
    if(NOT CMAKE_RC_COMPILER)
        SET(CMAKE_RC_COMPILER windres.exe)
    endif()

    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/zlib1rc.obj
                       COMMAND ${CMAKE_RC_COMPILER}
                            -D GCC_WINDRES
                            -I ${CMAKE_CURRENT_SOURCE_DIR}
                            -I ${CMAKE_CURRENT_BINARY_DIR}
                            -o ${CMAKE_CURRENT_BINARY_DIR}/zlib1rc.obj
                            -i ${CMAKE_CURRENT_SOURCE_DIR}/win32/zlib1.rc)
    set(ZLIB_SRCS ${ZLIB_SRCS} ${CMAKE_CURRENT_BINARY_DIR}/zlib1rc.obj)
endif(MINGW)

add_library(zlib SHARED ${ZLIB_SRCS} ${ZLIB_PUBLIC_HDRS} ${ZLIB_PRIVATE_HDRS})
add_library(zlibstatic STATIC ${ZLIB_SRCS} ${ZLIB_PUBLIC_HDRS} ${ZLIB_PRIVATE_HDRS})
set_target_properties(zlib PROPERTIES DEFINE_SYMBOL ZLIB_DLL)
set_target_properties(zlib PROPERTIES SOVERSION 1)

if(NOT CYGWIN)
    # This property causes shared libraries on Linux to have the full version
    # encoded into their final filename.  We disable this on Cygwin because
    # it causes cygz-${ZLIB_FULL_VERSION}.dll to be created when cygz.dll
    # seems to be the default.
    #
    # This has no effect with MSVC, on that platform the version info for
    # the DLL comes from the resource file win32/zlib1.rc
    set_target_properties(zlib PROPERTIES VERSION ${ZLIB_FULL_VERSION})
endif()

if(UNIX)
    # On unix-like platforms the library is almost always called libz
   set_target_properties(zlib zlibstatic PROPERTIES OUTPUT_NAME z)
   set_target_properties(zlib PROPERTIES LINK_FLAGS "-Wl,--version-script,${CMAKE_CURRENT_SOURCE_DIR}/zlib.map")
elseif(BUILD_SHARED_LIBS AND WIN32)
    # Creates zlib1.dll when building shared library version
    set_target_properties(zlib PROPERTIES SUFFIX "1.dll")
endif()

if(NOT SKIP_INSTALL_LIBRARIES AND NOT SKIP_INSTALL_ALL )
    install(TARGETS zlib zlibstatic
        RUNTIME DESTINATION "${INSTALL_BIN_DIR}"
        ARCHIVE DESTINATION "${INSTALL_LIB_DIR}"
        LIBRARY DESTINATION "${INSTALL_LIB_DIR}" )
endif()
if(NOT SKIP_INSTALL_HEADERS AND NOT SKIP_INSTALL_ALL )
    install(FILES ${ZLIB_PUBLIC_HDRS} DESTINATION "${INSTALL_INC_DIR}")
endif()
if(NOT SKIP_INSTALL_FILES AND NOT SKIP_INSTALL_ALL )
    install(FILES zlib.3 DESTINATION "${INSTALL_MAN_DIR}/man3")
endif()
if(NOT SKIP_INSTALL_FILES AND NOT SKIP_INSTALL_ALL )
    install(FILES ${ZLIB_PC} DESTINATION "${INSTALL_PKGCONFIG_DIR}")
endif()

#============================================================================
# Example binaries
#============================================================================

#add_executable(example test/example.c)
#target_link_libraries(example zlib)
#add_test(example example)

#add_executable(minigzip test/minigzip.c)
#target_link_libraries(minigzip zlib)

#if(HAVE_OFF64_T)
#    add_executable(example64 test/example.c)
#    target_link_libraries(example64 zlib)
#    set_target_properties(example64 PROPERTIES COMPILE_FLAGS "-D_FILE_OFFSET_BITS=64")
#    add_test(example64 example64)

#    add_executable(minigzip64 test/minigzip.c)
#    target_link_libraries(minigzip64 zlib)
#    set_target_properties(minigzip64 PROPERTIES COMPILE_FLAGS "-D_FILE_OFFSET_BITS=64")
#endif()

=== lib/angelscript/projects/cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE)
cmake_policy(SET CMP0003 NEW)

if(NOT (CMAKE_MAJOR_VERSION VERSION_LESS 3))
  cmake_policy(SET CMP0048 OLD)
endif()

project(angelscript)

option(BUILD_SHARED_LIBS "Build shared library" OFF)

if(APPLE)
    option(BUILD_FRAMEWORK "Build Framework bundle for OSX" OFF)
endif()

file(READ ../../include/angelscript.h ANGELSCRIPT_H)
string(REGEX MATCH "#define ANGELSCRIPT_VERSION_STRING \"([0-9]*).([0-9]*).([0-9]*)" ANGELSCRIPT_VERSION_REGEX ${ANGELSCRIPT_H})
set(ANGELSCRIPT_VERSION_MAJOR ${CMAKE_MATCH_1})
set(ANGELSCRIPT_VERSION_MINOR ${CMAKE_MATCH_2})
set(ANGELSCRIPT_VERSION_PATCH ${CMAKE_MATCH_3})
set(PROJECT_VERSION ${ANGELSCRIPT_VERSION_MAJOR}.${ANGELSCRIPT_VERSION_MINOR}.${ANGELSCRIPT_VERSION_PATCH})

message(STATUS "Configuring angelscript ${PROJECT_VERSION}")

find_package(Threads)

set(ANGELSCRIPT_HEADERS
    ../../include/angelscript.h
    ../../source/as_array.h
    ../../source/as_builder.h
    ../../source/as_bytecode.h
    ../../source/as_callfunc.h
    ../../source/as_compiler.h
    ../../source/as_config.h
    ../../source/as_configgroup.h
    ../../source/as_context.h
    ../../source/as_criticalsection.h
    ../../source/as_datatype.h
    ../../source/as_debug.h
    ../../source/as_generic.h
    ../../source/as_map.h
    ../../source/as_memory.h
    ../../source/as_module.h
    ../../source/as_objecttype.h
    ../../source/as_outputbuffer.h
    ../../source/as_parser.h
    ../../source/as_property.h
    ../../source/as_restore.h
    ../../source/as_scriptcode.h
    ../../source/as_scriptengine.h
    ../../source/as_scriptfunction.h
    ../../source/as_scriptnode.h
    ../../source/as_scriptobject.h
    ../../source/as_string.h
    ../../source/as_string_util.h
    ../../source/as_texts.h
    ../../source/as_thread.h
    ../../source/as_tokendef.h
    ../../source/as_tokenizer.h
    ../../source/as_typeinfo.h
    ../../source/as_variablescope.h
)

set(ANGELSCRIPT_SOURCE
    ../../source/as_atomic.cpp
    ../../source/as_builder.cpp
    ../../source/as_bytecode.cpp
    ../../source/as_callfunc.cpp
    ../../source/as_callfunc_mips.cpp
    ../../source/as_callfunc_x86.cpp
    ../../source/as_callfunc_x64_gcc.cpp
    ../../source/as_callfunc_x64_msvc.cpp
    ../../source/as_callfunc_x64_mingw.cpp
    ../../source/as_compiler.cpp
    ../../source/as_configgroup.cpp
    ../../source/as_context.cpp
    ../../source/as_datatype.cpp
    ../../source/as_gc.cpp
    ../../source/as_generic.cpp
    ../../source/as_globalproperty.cpp
    ../../source/as_memory.cpp
    ../../source/as_module.cpp
    ../../source/as_objecttype.cpp
    ../../source/as_outputbuffer.cpp
    ../../source/as_parser.cpp
    ../../source/as_restore.cpp
    ../../source/as_scriptcode.cpp
    ../../source/as_scriptengine.cpp
    ../../source/as_scriptfunction.cpp
    ../../source/as_scriptnode.cpp
    ../../source/as_scriptobject.cpp
    ../../source/as_string.cpp
    ../../source/as_string_util.cpp
    ../../source/as_thread.cpp
    ../../source/as_tokenizer.cpp
    ../../source/as_typeinfo.cpp
    ../../source/as_variablescope.cpp
)

if(MSVC AND CMAKE_CL_64)
    enable_language(ASM_MASM)
    if(CMAKE_ASM_MASM_COMPILER_WORKS)
        set(ANGELSCRIPT_SOURCE ${ANGELSCRIPT_SOURCE} ../../source/as_callfunc_x64_msvc_asm.asm)
    else()
        message(FATAL ERROR "MSVC x86_64 target requires a working assembler")
    endif()
endif()

if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "^arm")
    enable_language(ASM)
    if(CMAKE_ASM_COMPILER_WORKS)
        set(ANGELSCRIPT_SOURCE ${ANGELSCRIPT_SOURCE} ../../source/as_callfunc_arm.cpp ../../source/as_callfunc_arm_gcc.S)
        set_property(SOURCE ../../source/as_callfunc_arm_gcc.S APPEND PROPERTY COMPILE_FLAGS " -Wa,-mimplicit-it=always")
    else()
        message(FATAL ERROR "ARM target requires a working assembler")
    endif()
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../include)

if(MSVC)
    set(CMAKE_DEBUG_POSTFIX "d")
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)    
endif()

add_definitions(-DANGELSCRIPT_EXPORT -D_LIB)

# Fix x64 issues on Linux
if("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "x86_64" AND NOT APPLE)
    add_definitions(-fPIC)
endif()

if(NOT BUILD_FRAMEWORK)
    set(ANGELSCRIPT_LIBRARY_NAME angelscript)
else()
    set(ANGELSCRIPT_LIBRARY_NAME Angelscript) # OS X frameworks should have capitalized name
    set(BUILD_SHARED_LIBS TRUE)
endif()

add_library(${ANGELSCRIPT_LIBRARY_NAME} ${ANGELSCRIPT_SOURCE} ${ANGELSCRIPT_HEADERS})
#set(LIBRARY_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/../../lib)
target_link_libraries(${ANGELSCRIPT_LIBRARY_NAME} ${CMAKE_THREAD_LIBS_INIT})

set_target_properties(${ANGELSCRIPT_LIBRARY_NAME} PROPERTIES VERSION ${PROJECT_VERSION})

if(BUILD_FRAMEWORK)
    set_target_properties(${ANGELSCRIPT_LIBRARY_NAME} PROPERTIES
        FRAMEWORK TRUE
        FRAMEWORK_VERSION ${PROJECT_VERSION}
        MACOSX_FRAMEWORK_IDENTIFIER com.angelcode.Angelscript
        MACOSX_FRAMEWORK_SHORT_VERSION_STRING ${PROJECT_VERSION}
        MACOSX_FRAMEWORK_BUNDLE_VERSION ${PROJECT_VERSION}
        XCODE_ATTRIBUTE_INSTALL_PATH "@rpath"
        PUBLIC_HEADER ../../include/angelscript.h
    )
endif()

if(MSVC)
    set_target_properties(${ANGELSCRIPT_LIBRARY_NAME} PROPERTIES COMPILE_FLAGS "/MP")
endif()

#set(RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/../../bin)

#add_subdirectory(../../../samples/game/projects/cmake/ ./game)

=== debian/changelog ===
supertuxkart (0.9.3-1) unstable; urgency=medium

  * New upstream release.
    - Fix segfault in MusicInformation::isPlaying. (Closes: #873670)
    - Fix credits for Boom-boom-boom song. (Closes: #848001)
    - Remove obsolete patches: replace-fonts-ubuntu-with-cantarell.patch,
      update_boom_boom_boom_license.patch, fix_angelscript_ftbfs.patch,
      irrlicht/link-against-needed-libs.diff.
    - Refresh remaining patches.
  * Add new font dependencies for supertuxkart-data: fonts-freefont-ttf,
    fonts-noto-hinted,
  * Bump Standards version to 4.1.2.
    - Change priority of debug package from extra to optional.

 -- Vincent Cheng <vcheng@debian.org>  Sun, 17 Dec 2017 20:16:38 -0800

=== debian/control ===
Source: supertuxkart
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Sam Hocevar <sho@debian.org>,
 Vincent Cheng <vcheng@debian.org>
Build-Depends:
 cmake (>= 2.8.1),
 debhelper (>= 9),
 docbook-to-man,
 libalut-dev,
 libbluetooth-dev [linux-any],
 libbz2-dev,
 libcurl4-gnutls-dev | libcurl4-dev,
 libenet-dev (>= 1.3.1),
 libfreetype6-dev,
 libfribidi-dev,
 libjpeg-dev,
 libopenal-dev,
 libpng-dev,
 libsdl-image1.2-dev,
 libsdl-ttf2.0-dev,
 libvorbis-dev,
 libxrandr-dev,
 libxxf86vm-dev,
 mesa-common-dev,
 zlib1g-dev
Standards-Version: 4.1.2
Vcs-Svn: svn://anonscm.debian.org/pkg-games/packages/trunk/supertuxkart/
Vcs-Browser: https://anonscm.debian.org/viewvc/pkg-games/packages/trunk/supertuxkart/
Homepage: https://supertuxkart.net

Package: supertuxkart
Architecture: any
Depends:
 supertuxkart-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: 3D kart racing game
 SuperTuxKart is a free 3D kart racing game, with a focus on having fun over
 realism. You can play with up to 4 friends on one PC, racing against each
 other or just trying to beat the computer; single-player mode is also
 available.
 .
 See the great lighthouse or drive through the sand and visit the pyramids.
 Race underground or in space, watching the stars pass by. Or rest under the
 palm trees on the beach, watching the other karts overtake you. But don't eat
 the bananas! Watch for bowling balls, plungers, bubble gum and cakes thrown by
 your opponents.
 .
 You can do a single race against other karts, compete in one of several Grand
 Prix, try to beat the high score in time trials on your own, play battle mode
 against your friends, and more!

Package: supertuxkart-data
Architecture: all
Depends:
 fonts-cantarell,
 fonts-freefont-ttf,
 fonts-noto-hinted,
 ${misc:Depends}
Suggests:
 supertuxkart
Description: 3D kart racing game (data)
 SuperTuxKart is a free 3D kart racing game, with a focus on having fun over
 realism. You can play with up to 4 friends on one PC, racing against each
 other or just trying to beat the computer; single-player mode is also
 available.
 .
 See the great lighthouse or drive through the sand and visit the pyramids.
 Race underground or in space, watching the stars pass by. Or rest under the
 palm trees on the beach, watching the other karts overtake you. But don't eat
 the bananas! Watch for bowling balls, plungers, bubble gum and cakes thrown by
 your opponents.
 .
 You can do a single race against other karts, compete in one of several Grand
 Prix, try to beat the high score in time trials on your own, play battle mode
 against your friends, and more!
 .
 This package contains data files for the game supertuxkart.

Package: supertuxkart-dbg
Section: debug
Architecture: any
Depends:
 supertuxkart (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: 3D kart racing game (debug)
 SuperTuxKart is a free 3D kart racing game, with a focus on having fun over
 realism. You can play with up to 4 friends on one PC, racing against each
 other or just trying to beat the computer; single-player mode is also
 available.
 .
 See the great lighthouse or drive through the sand and visit the pyramids.
 Race underground or in space, watching the stars pass by. Or rest under the
 palm trees on the beach, watching the other karts overtake you. But don't eat
 the bananas! Watch for bowling balls, plungers, bubble gum and cakes thrown by
 your opponents.
 .
 You can do a single race against other karts, compete in one of several Grand
 Prix, try to beat the high score in time trials on your own, play battle mode
 against your friends, and more!
 .
 This package contains debugging symbols for the game supertuxkart.

=== debian/rules ===
#!/usr/bin/make -f

ifeq ($(findstring parallel=,$(DEB_BUILD_OPTIONS)),)
	export DEB_BUILD_OPTIONS+=parallel=$(shell getconf _NPROCESSORS_ONLN)
endif

export DEB_LDFLAGS_MAINT_APPEND=-lGLU

DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

%:
	dh $@ --buildsystem=cmake --parallel

override_dh_auto_clean:
	# Remove embedded libraries used by embedded Irrlicht
	rm -rf lib/jpeglib/
	rm -rf lib/zlib/
	rm -rf lib/libpng/
	
	dh_auto_clean

override_dh_auto_configure:	
	# libbluetooth-dev is only available on linux, hence build with
	# wiimote input device support only on linux
	# TODO: remove -DBUILD_RECORDER=0 once libopenglrecorder is packaged
	if [ $(DEB_HOST_ARCH_OS) = linux ]; then \
	dh_auto_configure -- -DCMAKE_BUILD_TYPE="STKRelease" \
	                     -DSTK_INSTALL_BINARY_DIR="games" \
	                     -DSTK_INSTALL_DATA_DIR="share/games/supertuxkart" \
	                     -DBUILD_RECORDER=0; \
	else \
	dh_auto_configure -- -DCMAKE_BUILD_TYPE="STKRelease" \
	                     -DSTK_INSTALL_BINARY_DIR="games" \
	                     -DSTK_INSTALL_DATA_DIR="share/games/supertuxkart" \
	                     -DUSE_WIIUSE=OFF \
	                     -DBUILD_RECORDER=0; \
	fi

override_dh_auto_build:
	# Generate manual page	 
	docbook-to-man debian/supertuxkart.sgml > debian/supertuxkart.6
	
	dh_auto_build

override_dh_install:
	# Licenses are all documented in debian/copyright
	find $(CURDIR)/debian/tmp \( -iname "LICENSE" -o -iname "License.txt" \
	-o -iname "license2.txt" -o -iname "licence2.txt" -o -iname \
	"License.Debian.txt" -o -iname "Music_license.rtf" \) -delete
	
	# cmake installs some unneeded autotools-related files as well
	find $(CURDIR)/debian/tmp \( -iname "Makefile.am" -o -iname \
	"Makefile.in" \) -delete
	
	# Remove unneeded (developer) scripts in data directory
	find $(CURDIR)/debian/tmp \( -iname "run_me.sh" -o -iname \
	"optimize_data.sh" -o -iname "check.sh" -o -iname \
	"pull_from_transifex.sh" \) -delete
	
	dh_install --list-missing -Xgitignore -Xgitattributes

override_dh_strip:
	dh_strip --dbg-package=supertuxkart-dbg

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\d+$//g \
http://sf.net/supertuxkart/supertuxkart-([\d\.]*)-src\.(?:tar\.(?:gz|bz2|xz))
